/*
 * IoT Services Management System - 2021
 * See LICENSE for more information about licensing
 *
 * Author: Jose Ortega <ortega.josant@gmail.com>
 *         Luis G. Leon Vega <lleon95@gmail.com>
 *
 * Sponsor: Klooid Innovations 2021
 */
#include <iomanip>
#include <iostream>
#include <memory>
#include <thread>

#include <IIpcConnection.hpp>
#include <ConnectionPayload.hpp>
#include <IPayload.hpp>
#include <RequestType.hpp>

std::vector<std::shared_ptr<isms::kn::IPayload>> current_payloads;
std::shared_ptr<isms::kn::IIpcConnection> connection;

void ShowMessage(std::shared_ptr<isms::kn::IPayload>& payload) {
  std::cout << "Process ID: " << payload->get_pid() << std::endl;
  std::cout << "Received from: " << payload->get_origin_sid() << std::endl;
}

isms::kn::RequestType return_type_request(const std::string& type) {
  if (type == "comm") {
    return isms::kn::RequestType::kComm;
  } else if (type == "con") {
    return isms::kn::RequestType::kConnect;
  } else if (type == "dcon") {
    return isms::kn::RequestType::kDisconnect;
  } else if (type == "proc") {
    return isms::kn::RequestType::kProc;
  } else if (type == "db") {
    return isms::kn::RequestType::kDb;
  } else if (type == "sp") {
    return isms::kn::RequestType::kStoragePermission;
  } else if (type == "resp") {
    return isms::kn::RequestType::kResponse;
  } else
    return isms::kn::RequestType::kComm;
}

void ShowCurrentProcess() {
  std::system("clear");
  const char separator = ' ';
  const char pipe = '|';
  const int width = 12;
  std::system("clear");
  std::cout << std::left << std::setw(width) << std::setfill(separator) << "PID"
            << pipe;
  std::cout << std::left << std::setw(width) << std::setfill(separator)
            << "SubProcess" << pipe;
  std::cout << std::endl;
  for (auto payload : current_payloads) {
    std::cout << std::left << std::setw(width) << std::setfill(separator)
              << payload->get_pid() << pipe;
    std::cout << std::left << std::setw(width) << std::setfill(separator)
              << payload->IsSubprocess() << pipe;
    std::cout << std::endl;
  }
}

std::shared_ptr<isms::kn::IPayload> GetPayload(const int pid) {
  for (auto& payload : current_payloads) {
    if (payload->get_pid() == pid) {
      return payload;
    }
  }
  return nullptr;
}

int RemovePayload(const int pid) {
  int i = 0;
  for (auto& payload : current_payloads) {
    if (payload->get_pid() == pid) {
      auto payload_send = payload;
      current_payloads.erase(current_payloads.begin() + i);
      return pid;
    }
    ++i;
  }
  return -1;
}

void SendMessage(const std::string& request_type,
                 const std::shared_ptr<isms::kn::IPayload>& payload) {
  auto type_req = return_type_request(request_type);
  isms::kn::ErrorType send_result;
  if (type_req == isms::kn::RequestType::kResponse)
    send_result = connection->SendResponse(payload);
  else
    send_result = connection->SendRequest(type_req, payload);
  if (send_result != isms::kn::ErrorType::kSuccess)
    std::cout << "Cannot send the message" << std::endl;
}

/**
 * Autogenerated main for Meson empty project
 */
int main(int argc, char** argv) {
  std::string type_request;

  std::cout << "-> Insert type of service:" << std::endl;

  std::cin >> type_request;

  auto type_r = return_type_request(type_request);

  connection = isms::kn::IIpcConnection::Build();
  connection->set_recv_timeout(3000);

  connection->set_comm_protocol("ipc");
  connection->set_kernel_endpoint("kernel_0.ipc");
  connection->set_type_of_service(type_r);

  connection->InitIpc();

  while (type_request != "dcon") {
    std::cout << "\n --- Insert request to do: ---\n\
    + Response - resp\n\
    + Request - req\n\
    + Subproces - sub\n\
    + PopRequest - preq\n\
    + PopResponse - presp\n\
    + Disconnect - dcon"
              << std::endl;

    std::cin >> type_request;

    if (type_request == "resp") {
      ShowCurrentProcess();
      std::string pid_input;
      std::cout << " --- Insert PID To Respond: ---\n-->" << std::endl;
      std::cin >> pid_input;

      auto pid = std::stoi(pid_input);
      auto payload = GetPayload(pid);
      if (nullptr == payload) continue;
      payload->set_subprocess(false);
      SendMessage(type_request, payload);
      RemovePayload(pid);

    } else if (type_request == "req") {
      std::string input;
      std::cout << " --- Insert Service to Request: ---\n-->" << std::endl;

      std::cin >> input;

      auto payload = isms::kn::IPayload::Create();

      SendMessage(input, payload);

    } else if (type_request == "sub") {
      ShowCurrentProcess();
      std::string pid_input;
      std::string req_type;
      std::cout << "\n --- Insert PID To Request: ---" << std::endl;
      std::cin >> pid_input;
      std::cout << "\n --- Insert Service to Request: ---" << std::endl;
      std::cin >> req_type;
      auto pid = std::stoi(pid_input);
      auto payload = GetPayload(pid);
      if (nullptr == payload) continue;
      payload->set_subprocess(true);
      SendMessage(req_type, payload);
      RemovePayload(pid);

    } else if (type_request == "preq") {
      auto request = connection->PopRequest();
      if (request) {
        ShowMessage(request);
        current_payloads.push_back(request);
      } else {
        std::cout << "Invalid" << std::endl;
      }
      continue;
    } else if (type_request == "presp") {
      auto response = connection->PopResponse();
      if (response) {
        ShowMessage(response);
        current_payloads.push_back(response);
      } else {
        std::cout << "Invalid" << std::endl;
      }
      continue;
    }
     else if (type_request == "dcon") {
      auto payload = isms::kn::IPayload::Create();
      SendMessage(type_request, payload);
    } else
      continue;
  }
}
